import { ModalFormData, ActionFormData } from '@minecraft/server-ui';
import { world, system } from '@minecraft/server';

//_________________________________/ Database \_________________________________\\

class DataBase {
    AnnouncementTitle = '';
    Announcement = '';

    constructor(DataBase) {
        if (!DataBase) return;
        Object.assign(this, DataBase);
    }
}

class Objectives {
    GetData() {
        // Retrieve the announcements from dynamic properties
        let storedData = world.getDynamicProperty('Announcement_DataStorage') || '[]';
        let Data = JSON.parse(storedData).map((item) => new DataBase(item));
        return Data;
    }

    SaveData(data) {
        // Save the announcements to dynamic properties
        let currentData = this.GetData();
        currentData.push(data);
        world.setDynamicProperty('Announcement_DataStorage', JSON.stringify(currentData));
    }

    RemoveData(data) {
        // Remove the specific data entry
        let currentData = this.GetData();
        currentData = currentData.filter((item) => item.AnnouncementTitle !== data.AnnouncementTitle);
        world.setDynamicProperty('Announcement_DataStorage', JSON.stringify(currentData));
    }
}

export const Objective = new Objectives();

//_________________________________/ Menus / Other Stuff \_________________________________\\

class TESTs {
    AnnouncementAdmin(player) {
        const form = new ModalFormData()
            .textField('Announcement Title (DO NOT MAKE IT LONG)', 'Awesome Announcement')
            .textField('Whats This Announcement', 'text');

        form.show(player).then((data) => {
            if (data.canceled) return;
            system.run(() => {
                // Save the new announcement using the dynamic properties
                const newAnnouncement = new DataBase({
                    AnnouncementTitle: data.formValues[0],
                    Announcement: data.formValues[1]
                });
                Objective.SaveData(newAnnouncement);
            });
        });
    }
}

export const TEST = new TESTs();

// Initialize dynamic properties if not already set
if (!world.getDynamicProperty('Announcement_DataStorage')) {
    world.setDynamicProperty('Announcement_DataStorage', '[]');
}
